<?php

/**
 * Custom fields and filters of post
 *
 * @package CustomFieldFilterPost
 * @version 2.0
 * @author davidhs
 * @copyright 2014-2018 by davidhs
 * @license Creative Commons Attribution 3.0 Unported License https://creativecommons.org/licenses/by/3.0/
 */

if (!defined('SMF'))
	die('Hacking attempt...');

// Adds things on load theme.
function cffp_load_theme($reload = '')
{
	global $context, $settings, $smcFunc;

	db_extend('packages');

	// Columns of tables.
	if (empty($reload))
		$context['cffp']['list_columns'] = array();

	if (empty($reload) || 'list_columns_fields' == $reload)
		$context['cffp']['list_columns']['fields'] = $smcFunc['db_list_columns']('{db_prefix}cffp_fields');
	if (empty($reload) || 'list_columns_members' == $reload)
	{
		$context['cffp']['list_columns']['members'] = array_filter($smcFunc['db_list_columns']('{db_prefix}members'), create_function('$column', 'return preg_match(\'~^cffp[1-9][0-9]*_(groups|id_membergroup)$~\', $column);'));
		$context['cffp']['counter_records_ids'] = !empty($context['cffp']['list_columns']['members']) ? array_filter(array_map(create_function('$column', 'return preg_match(\'~^cffp([1-9][0-9]*)_groups$~\', $column, $matches) ? $matches[1] : \'\';'), $context['cffp']['list_columns']['members']), create_function('$column', 'return !empty($column);')) : array();
		if ('list_columns_members' == $reload && !empty($context['cffp']['settings_groups']) && !empty($context['cffp']['counter_records_ids']))
			usort($context['cffp']['counter_records_ids'], create_function('$id1, $id2', 'global $context; if (empty($context[\'cffp\'][\'settings_groups\'][$id1]) || empty($context[\'cffp\'][\'settings_groups\'][$id2]) || $context[\'cffp\'][\'settings_groups\'][$id1][\'group_order\'] == $context[\'cffp\'][\'settings_groups\'][$id2][\'group_order\']) return 0; else return $context[\'cffp\'][\'settings_groups\'][$id1][\'group_order\'] < $context[\'cffp\'][\'settings_groups\'][$id2][\'group_order\'] ? -1 : 1;'));
	}

	if (!empty($reload))
		return;

	$context['cffp']['list_columns']['settings_groups'] = $smcFunc['db_list_columns']('{db_prefix}cffp_settings_groups');
	$context['cffp']['list_columns']['settings_fields'] = $smcFunc['db_list_columns']('{db_prefix}cffp_settings_fields');
	$context['cffp']['list_columns']['stats'] = $smcFunc['db_list_columns']('{db_prefix}cffp_stats');

	// Settings of active groups and fields.
	$context['cffp']['settings_groups'] = array();

	$request = $smcFunc['db_query']('', '
		SELECT ' . implode(', ', $context['cffp']['list_columns']['settings_groups']) . '
		FROM {db_prefix}cffp_settings_groups
		WHERE active = {int:active}
		ORDER BY group_order ASC',
		array(
			'active' => 1,
		)
	);
	while ($row = $smcFunc['db_fetch_assoc']($request))
	{
		$context['cffp']['settings_groups'][$row['id_group']] = $row;
		$context['cffp']['settings_groups'][$row['id_group']]['settings_fields'] = array();
	}
	$smcFunc['db_free_result']($request);

	if (!empty($context['cffp']['settings_groups']) && !empty($context['cffp']['counter_records_ids']))
		usort($context['cffp']['counter_records_ids'], create_function('$id1, $id2', 'global $context; if (empty($context[\'cffp\'][\'settings_groups\'][$id1]) || empty($context[\'cffp\'][\'settings_groups\'][$id2]) || $context[\'cffp\'][\'settings_groups\'][$id1][\'group_order\'] == $context[\'cffp\'][\'settings_groups\'][$id2][\'group_order\']) return 0; else return $context[\'cffp\'][\'settings_groups\'][$id1][\'group_order\'] < $context[\'cffp\'][\'settings_groups\'][$id2][\'group_order\'] ? -1 : 1;'));

	$context['cffp']['settings_vars'] = array();
	if (!empty($context['cffp']['settings_groups']))
	{
		$request = $smcFunc['db_query']('', '
			SELECT ' . implode(', ', $context['cffp']['list_columns']['settings_fields']) . '
			FROM {db_prefix}cffp_settings_fields
			WHERE id_group IN ({array_int:id_group})
				AND active = {int:active}
			ORDER BY field_order ASC',
			array(
				'id_group' => array_keys($context['cffp']['settings_groups']),
				'active' => 1,
			)
		);
		while ($row = $smcFunc['db_fetch_assoc']($request))
		{
			$context['cffp']['settings_vars']['{FIELD_' . $row['id_field'] . '_DATABASE}'] = 'column_' . $row['id_column'];
			$context['cffp']['settings_groups'][$row['id_group']]['settings_fields'][$row['id_field']] = $row;
		}
		$smcFunc['db_free_result']($request);
	}

	// Cache of values in options of combobox buttons or values used of select or combobox buttons.
	$context['cffp']['options_combobox'] = array();
	$context['cffp']['options_used'] = array();

	// Cache of values of fields.
	$context['cffp']['fields_value'] = array();

	// Cache of data of message and topic.
	$context['cffp']['data_msg_topic'] = array(
		'topic_new' => array(
			'sticky' => null,
			'locked' => null,
			'id_msg' => 0,
			'first_msg' => 1,
			'subject' => '',
		),
	);

	// Statistics of records.
	$context['cffp']['stats_records'] = array(
		'total' => array(),
		'average' => array(),
		'top_posters' => array(),
	);

	// Search pages.
	cffpGetSearchPages();

	// Lists of Moderation Center.
	$context['cffp']['moderation_list'] = array();
	foreach ($context['cffp']['settings_groups'] as $id_group => $settings_group)
	{
		if (!$settings_group['moderation_list_show'])
			continue;

		$context['cffp']['moderation_list'][$id_group] = array(
			'name' => cffpIsNotEmptyString($settings_group['moderation_list_name']) ? $settings_group['moderation_list_name'] : $settings_group['name'],
			'menu' => $settings_group['moderation_list_menu'],
		);
	}

	// HTML headers.
	$context['html_headers'] .= '
	<script type="text/javascript" src="' . $settings['default_theme_url'] . '/scripts/CustomFieldFilterPost.js?fin20"></script>';
}

?>