<?php

/**
 * Custom fields and filters of post
 *
 * @package CustomFieldFilterPost
 * @version 2.0
 * @author davidhs
 * @copyright 2014-2018 by davidhs
 * @license Creative Commons Attribution 3.0 Unported License https://creativecommons.org/licenses/by/3.0/
 */

if (file_exists(dirname(__FILE__) . '/SSI.php') && !defined('SMF'))
	require_once (dirname(__FILE__) . '/SSI.php');
elseif (!defined('SMF'))
	exit('<b>Error:</b> Cannot install - please verify you put this in the same place as SMF\'s index.php.');

// Installs.
if (empty($context['uninstalling']))
{
	global $db_prefix;

	db_extend('packages');

	$tables = array(
		'cffp_fields' => array(
			'columns' => array(
				array(
					'name' => 'id_cffp',
					'type' => 'int',
					'size' => 10,
					'auto' => true,
					'deprecated_name' => 'ID_CFFP',
				),
				array(
					'name' => 'id_msg',
					'type' => 'int',
					'size' => 10,
					'default' => '0',
					'deprecated_name' => 'ID_MSG',
				),
				array(
					'name' => 'id_group',
					'type' => 'int',
					'size' => 10,
					'default' => '0',
					'deprecated_name' => 'ID_GROUP',
				),
				array(
					'name' => 'id_member',
					'type' => 'int',
					'size' => 10,
					'default' => '0',
					'deprecated_name' => 'ID_MEMBER',
				),
				array(
					'name' => 'poster_name',
					'type' => 'varchar',
					'size' => 255,
					'default' => '',
					'deprecated_name' => 'posterName',
				),
				array(
					'name' => 'poster_email',
					'type' => 'varchar',
					'size' => 255,
					'default' => '',
					'deprecated_name' => 'posterEmail',
				),
				array(
					'name' => 'poster_ip',
					'type' => 'varchar',
					'size' => 255,
					'default' => '',
					'deprecated_name' => 'posterIP',
				),
				array(
					'name' => 'poster_time',
					'type' => 'int',
					'size' => 10,
					'default' => '0',
					'deprecated_name' => 'posterTime',
				),
				array(
					'name' => 'modified_name',
					'type' => 'varchar',
					'size' => 255,
					'default' => '',
					'deprecated_name' => 'modifiedName',
				),
				array(
					'name' => 'modified_time',
					'type' => 'int',
					'size' => 10,
					'default' => '0',
					'deprecated_name' => 'modifiedTime',
				),
			),
			'indexes' => array(
				array(
					'type' => 'primary',
					'columns' => array('id_cffp'),
				),
			),
		),
		'cffp_membergroups' => array(
			'columns' => array(
				array(
					'name' => 'id_membergroup',
					'type' => 'int',
					'size' => 10,
					'auto' => true,
					'deprecated_name' => 'ID_MEMBERGROUP',
				),
				array(
					'name' => 'id_group',
					'type' => 'int',
					'size' => 10,
					'default' => '0',
					'deprecated_name' => 'ID_GROUP',
				),
				array(
					'name' => 'name',
					'type' => 'varchar',
					'size' => 40,
					'default' => '',
				),
				array(
					'name' => 'description',
					'type' => 'varchar',
					'size' => 255,
					'default' => '',
				),
				array(
					'name' => 'online_color',
					'type' => 'varchar',
					'size' => 20,
					'default' => '',
					'deprecated_name' => 'onlineColor',
				),
				array(
					'name' => 'min_groups',
					'type' => 'mediumint',
					'size' => 9,
					'default' => '0',
					'unsigned' => true,
					'deprecated_name' => 'minGroups',
				),
				array(
					'name' => 'stars',
					'type' => 'varchar',
					'size' => 255,
					'default' => '',
				),
				array(
					'name' => 'boards',
					'type' => 'text',
				),
				array(
					'name' => 'child_boards',
					'type' => 'tinyint',
					'size' => 3,
					'default' => '0',
					'null' => true,
				),
			),
			'indexes' => array(
				array(
					'type' => 'primary',
					'columns' => array('id_membergroup'),
				),
			),
		),
		'cffp_stats' => array(
			'columns' => array(
				array(
					'name' => 'id_stats',
					'type' => 'int',
					'size' => 10,
					'auto' => true,
					'deprecated_name' => 'ID_STATS',
				),
				array(
					'name' => 'id_msg',
					'type' => 'int',
					'size' => 10,
					'default' => '0',
					'deprecated_name' => 'ID_MSG',
				),
				array(
					'name' => 'id_group',
					'type' => 'int',
					'size' => 10,
					'default' => '0',
					'deprecated_name' => 'ID_GROUP',
				),
				array(
					'name' => 'data',
					'type' => 'text',
				),
				array(
					'name' => 'options_text',
					'type' => 'text',
				),
				array(
					'name' => 'is_numeric',
					'type' => 'tinyint',
					'size' => 3,
					'default' => '0',
				),
				array(
					'name' => 'average',
					'type' => 'float',
					'size' => 10,
					'default' => null,
					'null' => true,
				),
				array(
					'name' => 'sum',
					'type' => 'float',
					'size' => 10,
					'default' => null,
					'null' => true,
				),
				array(
					'name' => 'max',
					'type' => 'float',
					'size' => 10,
					'default' => null,
					'null' => true,
				),
				array(
					'name' => 'min',
					'type' => 'float',
					'size' => 10,
					'default' => null,
					'null' => true,
				),
				array(
					'name' => 'highest',
					'type' => 'float',
					'size' => 10,
					'default' => null,
					'null' => true,
				),
				array(
					'name' => 'lowest',
					'type' => 'float',
					'size' => 10,
					'default' => null,
					'null' => true,
				),
				array(
					'name' => 'most_frequent',
					'type' => 'text',
				),
				array(
					'name' => 'least_frequent',
					'type' => 'text',
				),
				array(
					'name' => 'total',
					'type' => 'int',
					'size' => 10,
					'default' => '0',
				),
			),
			'indexes' => array(
				array(
					'type' => 'primary',
					'columns' => array('id_stats'),
				),
			),
		),
		'cffp_settings_fields' => array(
			'columns' => array(
				array(
					'name' => 'id_field',
					'type' => 'int',
					'size' => 10,
					'auto' => true,
					'deprecated_name' => 'ID_FIELD',
				),
				array(
					'name' => 'id_group',
					'type' => 'int',
					'size' => 10,
					'default' => '0',
					'deprecated_name' => 'ID_GROUP',
				),
				array(
					'name' => 'id_column',
					'type' => 'int',
					'size' => 10,
					'default' => '0',
				),
				array(
					'name' => 'name',
					'type' => 'varchar',
					'size' => 40,
					'default' => '',
				),
				array(
					'name' => 'field_desc',
					'type' => 'varchar',
					'size' => 255,
					'default' => '',
				),
				array(
					'name' => 'field_long_desc',
					'type' => 'text',
				),
				array(
					'name' => 'field_search_desc',
					'type' => 'varchar',
					'size' => 255,
					'default' => '',
				),
				array(
					'name' => 'field_search_long_desc',
					'type' => 'text',
				),
				array(
					'name' => 'description',
					'type' => 'varchar',
					'size' => 255,
					'default' => '',
				),
				array(
					'name' => 'field_order',
					'type' => 'tinyint',
					'size' => 3,
					'default' => '0',
				),
				array(
					'name' => 'type',
					'type' => 'varchar',
					'size' => 8,
					'default' => 'text',
				),
				array(
					'name' => 'type_filter',
					'type' => 'varchar',
					'size' => 15,
					'default' => 'text',
				),
				array(
					'name' => 'length',
					'type' => 'smallint',
					'size' => 5,
					'default' => '255',
				),
				array(
					'name' => 'options',
					'type' => 'text',
				),
				array(
					'name' => 'options_text',
					'type' => 'text',
				),
				array(
					'name' => 'mask',
					'type' => 'varchar',
					'size' => 255,
					'default' => '',
				),
				array(
					'name' => 'bbc',
					'type' => 'tinyint',
					'size' => 3,
					'default' => '0',
				),
				array(
					'name' => 'default_value',
					'type' => 'text',
				),
				array(
					'name' => 'text_previous',
					'type' => 'text',
				),
				array(
					'name' => 'text_next',
					'type' => 'text',
				),
				array(
					'name' => 'enclose_type',
					'type' => 'varchar',
					'size' => 4,
					'default' => 'html',
				),
				array(
					'name' => 'enclose_text',
					'type' => 'text',
				),
				array(
					'name' => 'show_message_index',
					'type' => 'tinyint',
					'size' => 3,
					'default' => '0',
				),
				array(
					'name' => 'show_filter_operator',
					'type' => 'tinyint',
					'size' => 3,
					'default' => '0',
				),
				array(
					'name' => 'hide_filter',
					'type' => 'varchar',
					'size' => 40,
					'default' => '',
				),
				array(
					'name' => 'show_filter_used_options',
					'type' => 'tinyint',
					'size' => 3,
					'default' => '0',
				),
				array(
					'name' => 'show_record_list_type',
					'type' => 'varchar',
					'size' => 5,
					'default' => 'no',
				),
				array(
					'name' => 'show_record_list_width',
					'type' => 'varchar',
					'size' => 7,
					'default' => '',
				),
				array(
					'name' => 'show_record_list_name',
					'type' => 'varchar',
					'size' => 40,
					'default' => '',
				),
				array(
					'name' => 'show_moderation_list_type',
					'type' => 'varchar',
					'size' => 5,
					'default' => 'no',
				),
				array(
					'name' => 'show_moderation_list_width',
					'type' => 'varchar',
					'size' => 7,
					'default' => '',
				),
				array(
					'name' => 'show_moderation_list_name',
					'type' => 'varchar',
					'size' => 40,
					'default' => '',
				),
				array(
					'name' => 'not_empty_value',
					'type' => 'tinyint',
					'size' => 3,
					'default' => '0',
				),
				array(
					'name' => 'unique_value',
					'type' => 'tinyint',
					'size' => 3,
					'default' => '0',
				),
				array(
					'name' => 'subset',
					'type' => 'varchar',
					'size' => 40,
					'default' => '',
				),
				array(
					'name' => 'permissions',
					'type' => 'text',
				),
				array(
					'name' => 'active',
					'type' => 'tinyint',
					'size' => 3,
					'default' => '1',
				),
			),
			'indexes' => array(
				array(
					'type' => 'primary',
					'columns' => array('id_field'),
				),
			),
		),
		'cffp_settings_groups' => array(
			'columns' => array(
				array(
					'name' => 'id_group',
					'type' => 'int',
					'size' => 10,
					'auto' => true,
					'deprecated_name' => 'ID_GROUP',
				),
				array(
					'name' => 'name',
					'type' => 'varchar',
					'size' => 40,
					'default' => '',
				),
				array(
					'name' => 'description',
					'type' => 'varchar',
					'size' => 255,
					'default' => '',
				),
				array(
					'name' => 'group_order',
					'type' => 'tinyint',
					'size' => 3,
					'default' => '0',
				),
				array(
					'name' => 'text_input_before',
					'type' => 'text',
				),
				array(
					'name' => 'text_input',
					'type' => 'text',
				),
				array(
					'name' => 'text_output',
					'type' => 'text',
				),
				array(
					'name' => 'boards',
					'type' => 'text',
				),
				array(
					'name' => 'child_boards',
					'type' => 'tinyint',
					'size' => 3,
					'default' => '0',
					'null' => true,
				),
				array(
					'name' => 'type',
					'type' => 'varchar',
					'size' => 10,
					'default' => 'fields',
				),
				array(
					'name' => 'show_group_name_message_index',
					'type' => 'tinyint',
					'size' => 3,
					'default' => '0',
				),
				array(
					'name' => 'show_group_name_filter',
					'type' => 'tinyint',
					'size' => 3,
					'default' => '0',
				),
				array(
					'name' => 'show_group_name_search',
					'type' => 'tinyint',
					'size' => 3,
					'default' => '0',
				),
				array(
					'name' => 'show_fields_name',
					'type' => 'tinyint',
					'size' => 3,
					'default' => '1',
				),
				array(
					'name' => 'show_fields_set',
					'type' => 'tinyint',
					'size' => 3,
					'default' => '0',
				),
				array(
					'name' => 'show_empty_fields_post',
					'type' => 'tinyint',
					'size' => 3,
					'default' => '0',
				),
				array(
					'name' => 'show_empty_fields_message_index',
					'type' => 'tinyint',
					'size' => 3,
					'default' => '0',
				),
				array(
					'name' => 'show_poster_data',
					'type' => 'tinyint',
					'size' => 3,
					'default' => '1',
				),
				array(
					'name' => 'show_modified_data',
					'type' => 'tinyint',
					'size' => 3,
					'default' => '1',
				),
				array(
					'name' => 'show_actions_as',
					'type' => 'varchar',
					'size' => 10,
					'default' => 'icon_text',
				),
				array(
					'name' => 'show_member_expanded',
					'type' => 'tinyint',
					'size' => 3,
					'default' => '0',
				),
				array(
					'name' => 'show_member_expanded_data',
					'type' => 'tinyint',
					'size' => 3,
					'default' => '0',
				),
				array(
					'name' => 'show_member_expanded_data_recent',
					'type' => 'tinyint',
					'size' => 3,
					'default' => '0',
				),
				array(
					'name' => 'show_member_expanded_new',
					'type' => 'tinyint',
					'size' => 3,
					'default' => '0',
				),
				array(
					'name' => 'show_member_recent_at_top',
					'type' => 'tinyint',
					'size' => 3,
					'default' => '0',
				),
				array(
					'name' => 'member_max_height',
					'type' => 'smallint',
					'size' => 5,
					'default' => '0',
				),
				array(
					'name' => 'member_one_value',
					'type' => 'tinyint',
					'size' => 3,
					'default' => '0',
				),
				array(
					'name' => 'show_stats',
					'type' => 'tinyint',
					'size' => 3,
					'default' => '0',
				),
				array(
					'name' => 'show_stats_post_text',
					'type' => 'text',
				),
				array(
					'name' => 'show_stats_post_chart_average',
					'type' => 'varchar',
					'size' => 40,
					'default' => '',
				),
				array(
					'name' => 'show_stats_post_chart_hbars',
					'type' => 'varchar',
					'size' => 40,
					'default' => '',
				),
				array(
					'name' => 'show_stats_post_chart_vbars',
					'type' => 'varchar',
					'size' => 40,
					'default' => '',
				),
				array(
					'name' => 'show_stats_post_summary',
					'type' => 'varchar',
					'size' => 100,
					'default' => '',
				),
				array(
					'name' => 'show_stats_message_index_text',
					'type' => 'text',
				),
				array(
					'name' => 'show_stats_message_index_chart_average',
					'type' => 'varchar',
					'size' => 40,
					'default' => '',
				),
				array(
					'name' => 'show_stats_message_index_chart_hbars',
					'type' => 'varchar',
					'size' => 40,
					'default' => '',
				),
				array(
					'name' => 'show_stats_message_index_chart_vbars',
					'type' => 'varchar',
					'size' => 40,
					'default' => '',
				),
				array(
					'name' => 'show_stats_message_index_summary',
					'type' => 'varchar',
					'size' => 100,
					'default' => '',
				),
				array(
					'name' => 'show_stats_order_by',
					'type' => 'varchar',
					'size' => 100,
					'default' => '',
				),
				array(
					'name' => 'show_sticky',
					'type' => 'tinyint',
					'size' => 3,
					'default' => null,
					'null' => true,
				),
				array(
					'name' => 'show_locked',
					'type' => 'tinyint',
					'size' => 3,
					'default' => null,
					'null' => true,
				),
				array(
					'name' => 'show_first_post_topic',
					'type' => 'tinyint',
					'size' => 3,
					'default' => '0',
				),
				array(
					'name' => 'show_replies_topic',
					'type' => 'tinyint',
					'size' => 3,
					'default' => '0',
				),
				array(
					'name' => 'no_show_with_subject_prefix',
					'type' => 'text',
				),
				array(
					'name' => 'show_in_topic',
					'type' => 'varchar',
					'size' => 11,
					'default' => 'no',
				),
				array(
					'name' => 'show_filters',
					'type' => 'text',
				),
				array(
					'name' => 'show_filters_operator',
					'type' => 'text',
				),
				array(
					'name' => 'javascript',
					'type' => 'text',
				),
				array(
					'name' => 'search_page_name',
					'type' => 'text',
				),
				array(
					'name' => 'search_page_order_by',
					'type' => 'text',
				),
				array(
					'name' => 'counter_show',
					'type' => 'tinyint',
					'size' => 3,
					'default' => '0',
				),
				array(
					'name' => 'counter_name',
					'type' => 'varchar',
					'size' => 40,
					'default' => '',
				),
				array(
					'name' => 'counter_number_name',
					'type' => 'varchar',
					'size' => 40,
					'default' => '',
				),
				array(
					'name' => 'counter_total_name',
					'type' => 'varchar',
					'size' => 40,
					'default' => '',
				),
				array(
					'name' => 'counter_average_name',
					'type' => 'varchar',
					'size' => 40,
					'default' => '',
				),
				array(
					'name' => 'top_poster_show',
					'type' => 'tinyint',
					'size' => 3,
					'default' => '0',
				),
				array(
					'name' => 'top_poster_name',
					'type' => 'varchar',
					'size' => 40,
					'default' => '',
				),
				array(
					'name' => 'profile_list_show',
					'type' => 'tinyint',
					'size' => 3,
					'default' => '0',
				),
				array(
					'name' => 'profile_list_name',
					'type' => 'varchar',
					'size' => 40,
					'default' => '',
				),
				array(
					'name' => 'moderation_list_show',
					'type' => 'tinyint',
					'size' => 3,
					'default' => '0',
				),
				array(
					'name' => 'moderation_list_menu',
					'type' => 'tinyint',
					'size' => 3,
					'default' => '0',
				),
				array(
					'name' => 'moderation_list_name',
					'type' => 'varchar',
					'size' => 40,
					'default' => '',
				),
				array(
					'name' => 'moderation_list_order_by',
					'type' => 'varchar',
					'size' => 40,
					'default' => '',
				),
				array(
					'name' => 'permissions',
					'type' => 'text',
				),
				array(
					'name' => 'active',
					'type' => 'tinyint',
					'size' => 3,
					'default' => '1',
				),
				array(
					'name' => 'template_quick_input_regex',
					'type' => 'text',
				),
				array(
					'name' => 'template_quick_input_params',
					'type' => 'text',
				),
				array(
					'name' => 'template_quick_input_help',
					'type' => 'text',
				),
				array(
					'name' => 'template_quick_input_show_modify',
					'type' => 'tinyint',
					'size' => 3,
					'default' => '0',
				),
				array(
					'name' => 'template_type',
					'type' => 'varchar',
					'size' => 4,
					'default' => 'html',
				),
				array(
					'name' => 'template_text',
					'type' => 'text',
				),
				array(
					'name' => 'template_message_index_type',
					'type' => 'varchar',
					'size' => 4,
					'default' => 'html',
				),
				array(
					'name' => 'template_message_index_text',
					'type' => 'text',
				),
			),
			'indexes' => array(
				array(
					'type' => 'primary',
					'columns' => array('id_group'),
				),
			),
		),
	);

	$current_tables = $smcFunc['db_list_tables'](false, '%cffp%');
	$real_prefix = preg_match('~^(`?)(.+?)\\1\\.(.*?)$~', $db_prefix, $match) === 1 ? $match[3] : $db_prefix;

	// Loop through each table and do what needed.
	$delete_stats = false;
	$cffp_stats_columns = in_array(strtolower($real_prefix . 'cffp_stats'), array_map('strtolower', $current_tables)) ? $smcFunc['db_list_columns']('{db_prefix}cffp_stats') : array();
	foreach ($tables as $table => $data)
	{
		if (in_array(strtolower($real_prefix . $table), array_map('strtolower', $current_tables)))
		{
			foreach ($data['columns'] as $column)
			{
				if (!isset($column['deprecated_name']) || !$smcFunc['db_change_column']('{db_prefix}' . $table, $column['deprecated_name'], $column))
				{
					$smcFunc['db_add_column']('{db_prefix}' . $table, $column);

					if (!empty($cffp_stats_columns) && !$delete_stats && 'cffp_stats' == $table && !in_array($column['name'], $cffp_stats_columns))
						$delete_stats = true;
				}
			}
			foreach ($data['indexes'] as $index)
				$smcFunc['db_add_index']('{db_prefix}' . $table, $index, array(), 'ignore');
		}
		else
			$smcFunc['db_create_table']('{db_prefix}' . $table, $data['columns'], $data['indexes'], array(), 'ignore');
	}

	// Removes deprecated columns.
	$deprecated_columns = array(
		'cffp_settings_fields' => array(
			'filter_message_index', // From 1.0 to 1.1.
		),
	);
	foreach ($deprecated_columns as $table => $columns)
	{
		if (in_array(strtolower($real_prefix . $table), array_map('strtolower', $current_tables)))
		{
			foreach ($columns as $name_field)
				$smcFunc['db_remove_column']('{db_prefix}' . $table, $name_field);
		}
	}

	// Deletes statistics.
	if ($delete_stats)
	{
		$smcFunc['db_query']('', '
			TRUNCATE TABLE {db_prefix}cffp_stats'
		);
	}

	// Upgrades from 1.5 to 2.0.
	$deprecated_table = 'cffp_count_groups';
	$members_columns = array(
		'groups' => array(
			'name' => '',
			'type' => 'mediumint',
			'size' => 8,
			'default' => '0',
			'unsigned' => true,
		),
		'id_membergroup' => array(
			'name' => '',
			'type' => 'int',
			'size' => 10,
			'default' => '0',
		),
	);
	if (in_array(strtolower($real_prefix . $deprecated_table), array_map('strtolower', $current_tables)))
	{
		$columns_deprecated_name = array(
			array(
				'name' => 'id_count',
				'type' => 'int',
				'size' => 10,
				'auto' => true,
				'deprecated_name' => 'ID_COUNT',
			),
			array(
				'name' => 'id_member',
				'type' => 'int',
				'size' => 10,
				'default' => '0',
				'deprecated_name' => 'ID_MEMBER',
			),
			array(
				'name' => 'id_group',
				'type' => 'int',
				'size' => 10,
				'default' => '0',
				'deprecated_name' => 'ID_GROUP',
			),
		);
		foreach ($columns_deprecated_name as $column)
			$smcFunc['db_change_column']('{db_prefix}' . $deprecated_table, $column['deprecated_name'], $column);

		$request = $smcFunc['db_query']('', '
			SELECT id_group
			FROM {db_prefix}cffp_settings_groups
			WHERE type = {string:type}
			ORDER BY id_group ASC',
			array(
				'type' => 'record',
			)
		);
		while ($row = $smcFunc['db_fetch_assoc']($request))
		{
			// Adds new colums.
			$members_columns['groups']['name'] = 'cffp' . $row['id_group'] . '_groups';
			$members_columns['id_membergroup']['name'] = 'cffp' . $row['id_group'] . '_id_membergroup';
			$smcFunc['db_add_column']('{db_prefix}members', $members_columns['groups']);
			$smcFunc['db_add_column']('{db_prefix}members', $members_columns['id_membergroup']);

			// Inserts values.
			$request2 = $smcFunc['db_query']('', '
				SELECT id_member, groups
				FROM {db_prefix}' . $deprecated_table . '
				WHERE id_group = {int:id_group}
					AND groups > {int:no_groups}',
				array(
					'id_group' => $row['id_group'],
					'no_groups' => 0,
				)
			);
			while ($row2 = $smcFunc['db_fetch_assoc']($request2))
			{
				if (function_exists('apache_reset_timeout'))
					@apache_reset_timeout();

				$smcFunc['db_query']('', '
					UPDATE {db_prefix}members
					SET {raw:groups_name} = {int:groups_value}
					WHERE id_member = {int:id_member}',
					array(
						'id_member' => $row2['id_member'],
						'groups_name' => $members_columns['groups']['name'],
						'groups_value' => $row2['groups'],
					)
				);
			}
			$smcFunc['db_free_result']($request2);
		}
		$smcFunc['db_free_result']($request);

		// Deletes deprecated table.
		$smcFunc['db_drop_table']('{db_prefix}' . $deprecated_table);

		// Copies counter name in counter total/average name.
		$smcFunc['db_query']('', '
			UPDATE {db_prefix}cffp_settings_groups
			SET counter_number_name = counter_name, counter_total_name = counter_name, counter_average_name = counter_name',
			array(
			)
		);
	}
	else
	{
		$request = $smcFunc['db_query']('', '
			SELECT DISTINCT cffpf.id_group
			FROM {db_prefix}cffp_fields AS cffpf
				INNER JOIN {db_prefix}cffp_settings_groups AS cffpsg ON (cffpsg.id_group = cffpf.id_group)
			WHERE type = {string:type}',
			array(
				'type' => 'record',
			)
		);
		while ($row = $smcFunc['db_fetch_assoc']($request))
		{
			if (function_exists('apache_reset_timeout'))
				@apache_reset_timeout();

			$members_columns['id_membergroup']['name'] = 'cffp' . $row['id_group'] . '_id_membergroup';
			$members_columns['id_membergroup']['deprecated_name'] = 'cffp' . $row['id_group'] . '_ID_MEMBERGROUP';
			$smcFunc['db_change_column']('{db_prefix}members', $members_columns['id_membergroup']['deprecated_name'], $members_columns['id_membergroup']);
		}
		$smcFunc['db_free_result']($request);
	}
}

?>